(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('rxjs'), require('lodash.orderby'), require('lodash.min')) :
    typeof define === 'function' && define.amd ? define('@troplabs/angular-datatable', ['exports', '@angular/core', '@angular/common', 'rxjs', 'lodash.orderby', 'lodash.min'], factory) :
    (global = global || self, factory((global.troplabs = global.troplabs || {}, global.troplabs['angular-datatable'] = {}), global.ng.core, global.ng.common, global.rxjs, global.orderBy, global.min));
}(this, (function (exports, core, common, rxjs, orderBy, min) { 'use strict';

    orderBy = orderBy && orderBy.hasOwnProperty('default') ? orderBy['default'] : orderBy;
    min = min && min.hasOwnProperty('default') ? min['default'] : min;

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/angular-datatable.directive.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @record
     */
    function SortEvent() { }
    if (false) {
        /** @type {?} */
        SortEvent.prototype.sortBy;
        /** @type {?} */
        SortEvent.prototype.sortOrder;
    }
    /**
     * @record
     */
    function PageEvent() { }
    if (false) {
        /** @type {?} */
        PageEvent.prototype.activePage;
        /** @type {?} */
        PageEvent.prototype.rowsOnPage;
        /** @type {?} */
        PageEvent.prototype.dataLength;
    }
    /**
     * @record
     */
    function DataEvent() { }
    if (false) {
        /** @type {?} */
        DataEvent.prototype.length;
    }
    var AngularDatatableDirective = /** @class */ (function () {
        function AngularDatatableDirective(differs) {
            this.differs = differs;
            this.inputData = [];
            this.sortBy = "";
            this.sortOrder = "asc";
            this.sortByChange = new core.EventEmitter();
            this.sortOrderChange = new core.EventEmitter();
            this.rowsOnPage = 1000;
            this.activePage = 1;
            this.mustRecalculateData = false;
            this.onSortChange = new rxjs.ReplaySubject(1);
            this.onPageChange = new core.EventEmitter();
            this.diff = differs.find([]).create(null);
        }
        /**
         * @return {?}
         */
        AngularDatatableDirective.prototype.getSort = /**
         * @return {?}
         */
        function () {
            return { sortBy: this.sortBy, sortOrder: this.sortOrder };
        };
        /**
         * @param {?} sortBy
         * @param {?} sortOrder
         * @return {?}
         */
        AngularDatatableDirective.prototype.setSort = /**
         * @param {?} sortBy
         * @param {?} sortOrder
         * @return {?}
         */
        function (sortBy, sortOrder) {
            if (this.sortBy !== sortBy || this.sortOrder !== sortOrder) {
                this.sortBy = sortBy;
                this.sortOrder = (/** @type {?} */ ((["asc", "desc"].includes(sortOrder) ? sortOrder : "asc")));
                this.mustRecalculateData = true;
                this.onSortChange.next({ sortBy: sortBy, sortOrder: (/** @type {?} */ (sortOrder)) });
                this.sortByChange.emit(this.sortBy);
                this.sortOrderChange.emit(this.sortOrder);
            }
        };
        /**
         * @return {?}
         */
        AngularDatatableDirective.prototype.getPage = /**
         * @return {?}
         */
        function () {
            return { activePage: this.activePage, rowsOnPage: this.rowsOnPage, dataLength: this.inputData.length };
        };
        /**
         * @param {?} activePage
         * @param {?} rowsOnPage
         * @return {?}
         */
        AngularDatatableDirective.prototype.setPage = /**
         * @param {?} activePage
         * @param {?} rowsOnPage
         * @return {?}
         */
        function (activePage, rowsOnPage) {
            if (this.rowsOnPage !== rowsOnPage || this.activePage !== activePage) {
                this.activePage = this.activePage !== activePage ? activePage : this.calculateNewActivePage(this.rowsOnPage, rowsOnPage);
                this.rowsOnPage = rowsOnPage;
                this.mustRecalculateData = true;
                this.onPageChange.emit({
                    activePage: this.activePage,
                    rowsOnPage: this.rowsOnPage,
                    dataLength: this.inputData ? this.inputData.length : 0
                });
            }
        };
        /**
         * @private
         * @param {?} previousRowsOnPage
         * @param {?} currentRowsOnPage
         * @return {?}
         */
        AngularDatatableDirective.prototype.calculateNewActivePage = /**
         * @private
         * @param {?} previousRowsOnPage
         * @param {?} currentRowsOnPage
         * @return {?}
         */
        function (previousRowsOnPage, currentRowsOnPage) {
            /** @type {?} */
            var firstRowOnPage = (this.activePage - 1) * previousRowsOnPage + 1;
            /** @type {?} */
            var newActivePage = Math.ceil(firstRowOnPage / currentRowsOnPage);
            return newActivePage;
        };
        /**
         * @private
         * @return {?}
         */
        AngularDatatableDirective.prototype.recalculatePage = /**
         * @private
         * @return {?}
         */
        function () {
            /** @type {?} */
            var lastPage = Math.ceil(this.inputData.length / this.rowsOnPage);
            this.activePage = lastPage < this.activePage ? lastPage : this.activePage;
            this.activePage = this.activePage || 1;
            this.onPageChange.emit({
                activePage: this.activePage,
                rowsOnPage: this.rowsOnPage,
                dataLength: this.inputData.length
            });
        };
        /**
         * @param {?} changes
         * @return {?}
         */
        AngularDatatableDirective.prototype.ngOnChanges = /**
         * @param {?} changes
         * @return {?}
         */
        function (changes) {
            if (changes["rowsOnPage"]) {
                this.rowsOnPage = changes["rowsOnPage"].previousValue;
                this.setPage(this.activePage, changes["rowsOnPage"].currentValue);
                this.mustRecalculateData = true;
            }
            if (changes["sortBy"] || changes["sortOrder"]) {
                if (!["asc", "desc"].includes(this.sortOrder)) {
                    console.warn("angular2-datatable: value for input mfSortOrder must be one of ['asc', 'desc'], but is:", this.sortOrder);
                    this.sortOrder = "asc";
                }
                if (this.sortBy) {
                    this.onSortChange.next({ sortBy: this.sortBy, sortOrder: this.sortOrder });
                }
                this.mustRecalculateData = true;
            }
            if (changes["inputData"]) {
                this.inputData = changes["inputData"].currentValue || [];
                this.recalculatePage();
                this.mustRecalculateData = true;
            }
        };
        /**
         * @return {?}
         */
        AngularDatatableDirective.prototype.ngDoCheck = /**
         * @return {?}
         */
        function () {
            /** @type {?} */
            var changes = this.diff.diff(this.inputData);
            if (changes) {
                this.recalculatePage();
                this.mustRecalculateData = true;
            }
            if (this.mustRecalculateData) {
                this.fillData();
                this.mustRecalculateData = false;
            }
        };
        /**
         * @private
         * @return {?}
         */
        AngularDatatableDirective.prototype.fillData = /**
         * @private
         * @return {?}
         */
        function () {
            this.activePage = this.activePage;
            this.rowsOnPage = this.rowsOnPage;
            /** @type {?} */
            var offset = (this.activePage - 1) * this.rowsOnPage;
            /** @type {?} */
            var data = this.inputData;
            /** @type {?} */
            var sortBy = this.sortBy;
            if (typeof sortBy === 'string' || sortBy instanceof String) {
                data = orderBy(data, this.caseInsensitiveIteratee((/** @type {?} */ (sortBy))), [this.sortOrder]);
            }
            else {
                data = orderBy(data, sortBy, [this.sortOrder]);
            }
            data = data.slice(offset, offset + this.rowsOnPage);
            this.data = data;
        };
        /**
         * @private
         * @param {?} sortBy
         * @return {?}
         */
        AngularDatatableDirective.prototype.caseInsensitiveIteratee = /**
         * @private
         * @param {?} sortBy
         * @return {?}
         */
        function (sortBy) {
            return (/**
             * @param {?} row
             * @return {?}
             */
            function (row) {
                var e_1, _a;
                /** @type {?} */
                var value = row;
                try {
                    for (var _b = __values(sortBy.split('.')), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var sortByProperty = _c.value;
                        if (value) {
                            value = value[sortByProperty];
                        }
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
                if (value && typeof value === 'string' || value instanceof String) {
                    return value.toLowerCase();
                }
                return value;
            });
        };
        AngularDatatableDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: 'table[mfData]',
                        exportAs: 'mfDataTable'
                    },] }
        ];
        /** @nocollapse */
        AngularDatatableDirective.ctorParameters = function () { return [
            { type: core.IterableDiffers }
        ]; };
        AngularDatatableDirective.propDecorators = {
            inputData: [{ type: core.Input, args: ["mfData",] }],
            sortBy: [{ type: core.Input, args: ["mfSortBy",] }],
            sortOrder: [{ type: core.Input, args: ["mfSortOrder",] }],
            sortByChange: [{ type: core.Output, args: ["mfSortByChange",] }],
            sortOrderChange: [{ type: core.Output, args: ["mfSortOrderChange",] }],
            rowsOnPage: [{ type: core.Input, args: ["mfRowsOnPage",] }],
            activePage: [{ type: core.Input, args: ["mfActivePage",] }]
        };
        return AngularDatatableDirective;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        AngularDatatableDirective.prototype.diff;
        /** @type {?} */
        AngularDatatableDirective.prototype.inputData;
        /** @type {?} */
        AngularDatatableDirective.prototype.sortBy;
        /** @type {?} */
        AngularDatatableDirective.prototype.sortOrder;
        /** @type {?} */
        AngularDatatableDirective.prototype.sortByChange;
        /** @type {?} */
        AngularDatatableDirective.prototype.sortOrderChange;
        /** @type {?} */
        AngularDatatableDirective.prototype.rowsOnPage;
        /** @type {?} */
        AngularDatatableDirective.prototype.activePage;
        /**
         * @type {?}
         * @private
         */
        AngularDatatableDirective.prototype.mustRecalculateData;
        /** @type {?} */
        AngularDatatableDirective.prototype.data;
        /** @type {?} */
        AngularDatatableDirective.prototype.onSortChange;
        /** @type {?} */
        AngularDatatableDirective.prototype.onPageChange;
        /**
         * @type {?}
         * @private
         */
        AngularDatatableDirective.prototype.differs;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/default-sorter.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DefaultSorterComponent = /** @class */ (function () {
        function DefaultSorterComponent(mfTable) {
            this.mfTable = mfTable;
            this.isSortedByMeAsc = false;
            this.isSortedByMeDesc = false;
        }
        /**
         * @return {?}
         */
        DefaultSorterComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            var _this = this;
            this.mfTable.onSortChange.subscribe((/**
             * @param {?} event
             * @return {?}
             */
            function (event) {
                _this.isSortedByMeAsc = (event.sortBy == _this.sortBy && event.sortOrder == "asc");
                _this.isSortedByMeDesc = (event.sortBy == _this.sortBy && event.sortOrder == "desc");
            }));
        };
        /**
         * @return {?}
         */
        DefaultSorterComponent.prototype.sort = /**
         * @return {?}
         */
        function () {
            if (this.isSortedByMeAsc) {
                this.mfTable.setSort(this.sortBy, "desc");
            }
            else {
                this.mfTable.setSort(this.sortBy, "asc");
            }
        };
        DefaultSorterComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'mf-default-sorter',
                        template: "\n  <a style=\"cursor: pointer\" (click)=\"sort()\" class=\"text-nowrap\">\n      <ng-content></ng-content>\n      <span *ngIf=\"isSortedByMeAsc\" class=\"glyphicon glyphicon-triangle-top fa fa-sort-up\" aria-hidden=\"true\"></span>\n      <span *ngIf=\"isSortedByMeDesc\" class=\"glyphicon glyphicon-triangle-bottom fa fa-sort-down\" aria-hidden=\"true\"></span>\n  </a>"
                    }] }
        ];
        /** @nocollapse */
        DefaultSorterComponent.ctorParameters = function () { return [
            { type: AngularDatatableDirective }
        ]; };
        DefaultSorterComponent.propDecorators = {
            sortBy: [{ type: core.Input, args: ["by",] }]
        };
        return DefaultSorterComponent;
    }());
    if (false) {
        /** @type {?} */
        DefaultSorterComponent.prototype.sortBy;
        /** @type {?} */
        DefaultSorterComponent.prototype.isSortedByMeAsc;
        /** @type {?} */
        DefaultSorterComponent.prototype.isSortedByMeDesc;
        /**
         * @type {?}
         * @private
         */
        DefaultSorterComponent.prototype.mfTable;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/paginator.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var PaginatorComponent = /** @class */ (function () {
        function PaginatorComponent(injectMfTable) {
            var _this = this;
            this.injectMfTable = injectMfTable;
            this.dataLength = 0;
            this.onPageChangeSubscriber = (/**
             * @param {?} event
             * @return {?}
             */
            function (event) {
                _this.activePage = event.activePage;
                _this.rowsOnPage = event.rowsOnPage;
                _this.dataLength = event.dataLength;
                _this.lastPage = Math.ceil(_this.dataLength / _this.rowsOnPage);
            });
        }
        /**
         * @param {?} changes
         * @return {?}
         */
        PaginatorComponent.prototype.ngOnChanges = /**
         * @param {?} changes
         * @return {?}
         */
        function (changes) {
            this.mfTable = this.inputMfTable || this.injectMfTable;
            this.onPageChangeSubscriber(this.mfTable.getPage());
            this.mfTable.onPageChange.subscribe(this.onPageChangeSubscriber);
        };
        /**
         * @param {?} pageNumber
         * @return {?}
         */
        PaginatorComponent.prototype.setPage = /**
         * @param {?} pageNumber
         * @return {?}
         */
        function (pageNumber) {
            this.mfTable.setPage(pageNumber, this.rowsOnPage);
        };
        /**
         * @param {?} rowsOnPage
         * @return {?}
         */
        PaginatorComponent.prototype.setRowsOnPage = /**
         * @param {?} rowsOnPage
         * @return {?}
         */
        function (rowsOnPage) {
            this.mfTable.setPage(this.activePage, rowsOnPage);
        };
        PaginatorComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'mf-paginator',
                        template: "<ng-content></ng-content>"
                    }] }
        ];
        /** @nocollapse */
        PaginatorComponent.ctorParameters = function () { return [
            { type: AngularDatatableDirective, decorators: [{ type: core.Optional }] }
        ]; };
        PaginatorComponent.propDecorators = {
            inputMfTable: [{ type: core.Input, args: ["mfTable",] }]
        };
        return PaginatorComponent;
    }());
    if (false) {
        /** @type {?} */
        PaginatorComponent.prototype.inputMfTable;
        /**
         * @type {?}
         * @private
         */
        PaginatorComponent.prototype.mfTable;
        /** @type {?} */
        PaginatorComponent.prototype.activePage;
        /** @type {?} */
        PaginatorComponent.prototype.rowsOnPage;
        /** @type {?} */
        PaginatorComponent.prototype.dataLength;
        /** @type {?} */
        PaginatorComponent.prototype.lastPage;
        /**
         * @type {?}
         * @private
         */
        PaginatorComponent.prototype.onPageChangeSubscriber;
        /**
         * @type {?}
         * @private
         */
        PaginatorComponent.prototype.injectMfTable;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/bootstrap-paginator.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BootstrapPaginatorComponent = /** @class */ (function () {
        function BootstrapPaginatorComponent() {
            this.rowsOnPageSet = [];
            this.minRowsOnPage = 0;
        }
        /**
         * @param {?} changes
         * @return {?}
         */
        BootstrapPaginatorComponent.prototype.ngOnChanges = /**
         * @param {?} changes
         * @return {?}
         */
        function (changes) {
            if (changes.rowsOnPageSet) {
                this.minRowsOnPage = min(this.rowsOnPageSet);
            }
        };
        BootstrapPaginatorComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'mf-bootstrap-paginator',
                        template: "\n    <mf-paginator #p [mfTable]=\"mfTable\">\n        <ul class=\"pagination\" *ngIf=\"p.dataLength > p.rowsOnPage\">\n            <li class=\"page-item\" [class.disabled]=\"p.activePage <= 1\" (click)=\"p.setPage(1)\">\n                <a class=\"page-link\" style=\"cursor: pointer\">&laquo;</a>\n            </li>\n            <li class=\"page-item\" *ngIf=\"p.activePage > 4 && p.activePage + 1 > p.lastPage\" (click)=\"p.setPage(p.activePage - 4)\">\n                <a class=\"page-link\" style=\"cursor: pointer\">{{p.activePage-4}}</a>\n            </li>\n            <li class=\"page-item\" *ngIf=\"p.activePage > 3 && p.activePage + 2 > p.lastPage\" (click)=\"p.setPage(p.activePage - 3)\">\n                <a class=\"page-link\" style=\"cursor: pointer\">{{p.activePage-3}}</a>\n            </li>\n            <li class=\"page-item\" *ngIf=\"p.activePage > 2\" (click)=\"p.setPage(p.activePage - 2)\">\n                <a class=\"page-link\" style=\"cursor: pointer\">{{p.activePage-2}}</a>\n            </li>\n            <li class=\"page-item\" *ngIf=\"p.activePage > 1\" (click)=\"p.setPage(p.activePage - 1)\">\n                <a class=\"page-link\" style=\"cursor: pointer\">{{p.activePage-1}}</a>\n            </li>\n            <li class=\"page-item active\">\n                <a class=\"page-link\" style=\"cursor: pointer\">{{p.activePage}}</a>\n            </li>\n            <li class=\"page-item\" *ngIf=\"p.activePage + 1 <= p.lastPage\" (click)=\"p.setPage(p.activePage + 1)\">\n                <a class=\"page-link\" style=\"cursor: pointer\">{{p.activePage+1}}</a>\n            </li>\n            <li class=\"page-item\" *ngIf=\"p.activePage + 2 <= p.lastPage\" (click)=\"p.setPage(p.activePage + 2)\">\n                <a class=\"page-link\" style=\"cursor: pointer\">{{p.activePage+2}}</a>\n            </li>\n            <li class=\"page-item\" *ngIf=\"p.activePage + 3 <= p.lastPage && p.activePage < 3\" (click)=\"p.setPage(p.activePage + 3)\">\n                <a class=\"page-link\" style=\"cursor: pointer\">{{p.activePage+3}}</a>\n            </li>\n            <li class=\"page-item\" *ngIf=\"p.activePage + 4 <= p.lastPage && p.activePage < 2\" (click)=\"p.setPage(p.activePage + 4)\">\n                <a class=\"page-link\" style=\"cursor: pointer\">{{p.activePage+4}}</a>\n            </li>\n            <li class=\"page-item\" [class.disabled]=\"p.activePage >= p.lastPage\" (click)=\"p.setPage(p.lastPage)\">\n                <a class=\"page-link\" style=\"cursor: pointer\">&raquo;</a>\n            </li>\n        </ul>\n        <ul class=\"pagination pull-right float-sm-right\" *ngIf=\"p.dataLength > minRowsOnPage\">\n            <li class=\"page-item\" *ngFor=\"let rows of rowsOnPageSet\" [class.active]=\"p.rowsOnPage===rows\" (click)=\"p.setRowsOnPage(rows)\">\n                <a class=\"page-link\" style=\"cursor: pointer\">{{rows}}</a>\n            </li>\n        </ul>\n    </mf-paginator>\n    "
                    }] }
        ];
        BootstrapPaginatorComponent.propDecorators = {
            rowsOnPageSet: [{ type: core.Input, args: ["rowsOnPageSet",] }],
            mfTable: [{ type: core.Input, args: ["mfTable",] }]
        };
        return BootstrapPaginatorComponent;
    }());
    if (false) {
        /** @type {?} */
        BootstrapPaginatorComponent.prototype.rowsOnPageSet;
        /** @type {?} */
        BootstrapPaginatorComponent.prototype.mfTable;
        /** @type {?} */
        BootstrapPaginatorComponent.prototype.minRowsOnPage;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/angular-datatable.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AngularDatatableModule = /** @class */ (function () {
        function AngularDatatableModule() {
        }
        AngularDatatableModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [
                            common.CommonModule
                        ],
                        declarations: [AngularDatatableDirective, DefaultSorterComponent, PaginatorComponent, BootstrapPaginatorComponent],
                        exports: [AngularDatatableDirective, DefaultSorterComponent, PaginatorComponent, BootstrapPaginatorComponent]
                    },] }
        ];
        return AngularDatatableModule;
    }());

    exports.AngularDatatableDirective = AngularDatatableDirective;
    exports.AngularDatatableModule = AngularDatatableModule;
    exports.BootstrapPaginatorComponent = BootstrapPaginatorComponent;
    exports.DefaultSorterComponent = DefaultSorterComponent;
    exports.PaginatorComponent = PaginatorComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=troplabs-angular-datatable.umd.js.map
